summaryrefslogtreecommitdiff
path: root/tests/chgrp/deref
diff options
context:
space:
mode:
Diffstat (limited to 'tests/chgrp/deref')
-rwxr-xr-xtests/chgrp/deref84
1 files changed, 84 insertions, 0 deletions
diff --git a/tests/chgrp/deref b/tests/chgrp/deref
new file mode 100755
index 0000000..413ae22
--- /dev/null
+++ b/tests/chgrp/deref
@@ -0,0 +1,84 @@
+#!/bin/sh
+# see if chgrp can change the group of a symlink
+
+# Copyright (C) 2000, 2004, 2005, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chgrp --version
+fi
+
+. $srcdir/../group-names
+
+pwd=`pwd`
+tmp=slink.$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework' 1>&2
+ (exit 1); exit 1
+fi
+
+set _ $groups; shift
+g1=$1
+g2=$2
+
+touch f
+ln -s f symlink
+
+chgrp -h $g2 symlink 2> /dev/null
+set _ `ls -ln symlink`
+g=$5
+test "$g" = $g2 || {
+ cat <<EOF 1>&2
+$0: skipping this test; your system doesn't support changing
+the owner or group of a symbolic link.
+EOF
+ (exit 77); exit 77
+}
+
+fail=0
+
+chgrp $g1 f
+set _ `ls -ln f`; g=$5; test "$g" = $g1 || fail=1
+
+chgrp -h $g2 symlink || fail=1
+set _ `ls -ln f`; g=$5; test "$g" = $g1 || fail=1
+set _ `ls -ln symlink`; g=$5; test "$g" = $g2 || fail=1
+
+# This should not change the group of f.
+chgrp -h $g2 symlink || fail=1
+set _ `ls -ln f`; g=$5; test "$g" = $g1 || fail=1
+set _ `ls -ln symlink`; g=$5; test "$g" = $g2 || fail=1
+
+chgrp $g2 f
+set _ `ls -ln f`; g=$5; test "$g" = $g2 || fail=1
+
+# This *should* change the group of f.
+# Though note that the diagnostic you'd get with -c is misleading in that
+# it says the `group of `symlink'' has been changed.
+chgrp --dereference $g1 symlink
+set _ `ls -ln f`; g=$5; test "$g" = $g1 || fail=1
+set _ `ls -ln symlink`; g=$5; test "$g" = $g2 || fail=1
+
+(exit $fail); exit $fail